map = {}

function editorLoad()
	tilesMenu = false
end


function setupTileInfo(w, h)
	height = h
	radius = h/2
	side = 3/2 * radius
	width = w
end

function loadTerrainTiles()
	TerrainTiles = {}
	TerrainTiles[1] = {love.graphics.newImage("TerrainTiles/Water.png"),"Water"}
	TerrainTiles[2] = {love.graphics.newImage("TerrainTiles/Sand.png"),"Sand"}
	TerrainTiles[3] = {love.graphics.newImage("TerrainTiles/Desert.png"),"Desert"}
	TerrainTiles[4] = {love.graphics.newImage("TerrainTiles/Grassland.png"),"Grassland"}
	TerrainTiles[5] = {love.graphics.newImage("TerrainTiles/Mountains.png"),"Mountains"}
end

function loadTerrainObjects()
	TerrainObjects = {}
end

function createNewMap(sizeX, sizeY)
	mapWidth = sizeX
	mapHeight = sizeY
	for i = 1, sizeX do
		map[i] = {}
		for e = 1, sizeY do
			map[i][e] = {1}
		end
	end
end

function drawMap()
	
	for i = 1, #map do
		for e = 1, #map[i] do
			love.graphics.draw(TerrainTiles[map[i][e][1]][1], i * side, e * height + i%2 * height/2)
		end
	end
end

function paintMap()
	if love.mouse.isDown(1) then
		local x = love.mouse.getX()
		local y = love.mouse.getY()
		
		if x >= 325 and x <= 485 then
			if y >= 570 and y <= 600 then
				viewclick = true
			end
		end
		if x >= 640 and x <=800 then
			if y >= 570 and y <= 600 then
			tileclick = true
		end
	end
		if viewclick == false and tileclick == false then
			local mapxt = false
			local mapyt = false
			local x = x / scale
			local y = y / scale
			local itile = math.floor((x-transx)/side)
			local yts = (y - transy) - itile%2 * (height/2)
			local etile = math.floor(yts/height)			
			local xt = (x - transx) - itile * side
			local yt = yts - etile * height
					
			if xt > radius * math.floor((1/2) - (yt/height)) then
				mapx = itile
				if mapx > 0 and mapx <= 50 then
					mapxt= true
				end
			else
				mapx = itile - 1
				if mapx > 0 and mapx <= 50 then
					mapxt= true
				end
			end
				
			if yt > height/2 then
				deltay = 1
			else 
				deltay = 0
			end
					
			if xt > radius * math.floor((1/2) - (yt /height)) then
				mapy = etile
				if mapy > 0 and mapy <= 30 then
					mapyt = true
				end
			else
				mapy = etile -mapx%2 + deltay
				if mapy > 0 and mapy <= 30 then
					mapyt= true
				end
			end
						
			if mapxt and mapyt then
				map[mapx][mapy][1] = 4
			end
		end
		viewclick = false
		tileclick = false
	end
end

function ClickMap(x, y)
	if x >= 325 and x <= 485 then
		if y >= 570 and y <= 600 then
			viewclick = true
		end
	end
	
	if x >= 640 and x <=800 then
		if y >= 570 and y <= 600 then
			tileclick = true
		end
	end
	
	if viewclick == false and tileclick == false then
		local mapxt = false
		local mapyt = false
		local x = x / scale
		local y = y / scale
		local itile = math.floor((x-transx)/side)
		local yts = (y - transy) - itile%2 * (height/2)
		local etile = math.floor(yts/height)			
		local xt = (x - transx) - itile * side
		local yt = yts - etile * height
				
		if xt > radius * math.floor((1/2) - (yt/height)) then
			mapx = itile
			if mapx > 0 and mapx <= 50 then
				mapxt= true
			end
		else
			mapx = itile - 1
			if mapx > 0 and mapx <= 50 then
				mapxt= true
			end
		end
			
		if yt > height/2 then
			deltay = 1
		else 
			deltay = 0
		end
				
		if xt > radius * math.floor((1/2) - (yt /height)) then
			mapy = etile
			if mapy > 0 and mapy <= 30 then
				mapyt = true
			end
		else
			mapy = etile -mapx%2 + deltay
			if mapy > 0 and mapy <= 30 then
				mapyt= true
			end
		end
					
		if mapxt and mapyt then
			map[mapx][mapy][1] = 4
		end
	end
	viewclick = false
	tileclick = false
end

function drawMenu()

	--File button
	love.graphics.setColor(50,50,50)
	love.graphics.rectangle("fill", 0, 570, 160, 30)
	love.graphics.setColor(125, 125, 125)
	love.graphics.rectangle("fill", 5, 575, 150, 20)
	love.graphics.setColor(0,0,0)
	love.graphics.print("File", 65, 577)
	
	--Tile button
	love.graphics.setColor(50,50,50)
	love.graphics.rectangle("fill", 640, 570, 160, 30)
	love.graphics.setColor(125, 125, 125)
	love.graphics.rectangle("fill", 645, 575, 150, 20)
	love.graphics.setColor(255,255,255)
	love.graphics.print("Tiles", 705, 577)
	
	--view button
	love.graphics.setColor(5,5,5)
	love.graphics.rectangle("fill", 325, 570, 160, 30)
	love.graphics.setColor(15, 15, 15)
	love.graphics.rectangle("fill", 330, 575, 150, 20)
	love.graphics.setColor(255,255,255)
	love.graphics.print("View "..scale, 380, 577)
	
	
	if tilesMenu then
		love.graphics.setColor(50,50,50)
		love.graphics.rectangle("fill", 695, 320, 50, 250)
		love.graphics.setColor(125, 125, 125)
		love.graphics.rectangle("fill", 700, 325, 40, 245)
		love.graphics.setColor(0,0,0)
		love.graphics.print("Tiles", 705, 577)
	end
end


function clickMenu(x, y)
	if x >= 325 and x <= 485 then
		if y >= 570 and y <= 600 then
			if scale == 1 then
				scale = 2
				transx = -100
				transy = -100
			elseif scale == 2 then
				scale = 1
				transx = (((mapWidth * width) / 2) / 2.75)
				transy = ((mapHeight * height)/ 10)
			end
		end
	end
	
	if x >= 640 and x <=800 then
		if y >= 570 and y <= 600 then
			if tilesMenu then
				tilesMenu = false
			else
				tilesMenu = true
			end
		end
	end
end